/* Copyright 2014 Bernhard R. Fischer.
 *
 * This file is part of DChat.
 *
 * DChat is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License.
 *
 * DChat is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with DChat. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MESSAGE_H
#define MESSAGE_H

#define E_MSG_TRUNC 0
#define E_MSG_HEAD1ILL -1
#define E_MSG_LENILL -2
#define E_MSG_PORTILL -3


typedef struct message
{
   int type;
   uint16_t port;
   char hostname[256];
   int len;
   char data[MAX_CONTENT_LENGTH];
} message_t;

typedef struct canon_addr
{
   int port;
   char name[256];
} canon_addr_t;

enum {MSG_UNKNOWN, MSG_TEXT, MSG_OCTET, MSG_DISCOVER};

int resync_buffer(contact_t *);
int parse_message(contact_t *, message_t *);
canon_addr_t *parse_canon_list(const message_t *);
int compose_raw_message(const message_t *, char *, int );
int mk_message(int , const char *, message_t *);
int mk_text_message(const char *, message_t *);
char *create_name_list(const contact_list_t *);
struct sockaddr_storage *parse_ip_list(const canon_addr_t *);
int str_to_port(const char *);

#endif

