/* Copyright 2014 Bernhard R. Fischer.
 *
 * This file is part of DChat.
 *
 * DChat is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License.
 *
 * DChat is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with DChat. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SOCKADDR_H
#define SOCKADDR_H


#define SA_LEN(x) ((x)->sa_family == AF_INET ? sizeof(struct sockaddr_in) : \
      (x)->sa_family == AF_INET6 ? sizeof(struct sockaddr_in6) : 0)

#define SA_AF_LT 0xff000000
#define SA_AF_GT 0x01000000
#define SA_ILL_FAMILY 0x80000000


int sockaddr_port(const struct sockaddr *);
int sockaddr_cmp_addr(const struct sockaddr *, const struct sockaddr *);
int sockaddr_cmp(const struct sockaddr* , const struct sockaddr *);
int sockaddr_to_string(char *, int , const struct sockaddr *);
int sockaddr_setport(struct sockaddr *, uint16_t );
void log_sockaddr(int lf, const struct sockaddr *);
int sockaddr_setlen(struct sockaddr *);
const void *sockaddr_addrptr(const struct sockaddr *);
int inet_ntop2(int , const void *, char *, socklen_t );

#endif

